<template>
  <st-content heading="Coordinadores">
    <st-register
      :key="componentKey"
      v-model="dialog"
      @refresh="refresh"
    />
    <div class="content-body">
      <div class="table-heading">
        <st-search
          text="Buscar por nombre o código"
          @enter="search($event)"
        />
        <st-primary-btn
          nombre="Registrar Coordinador"
          @click="open"
        />
      </div>
      <st-data-table
        :dataInfo = "{ headers,items }"
        :dataPath = "path"
        :loading = loading
      />
    </div>
  </st-content>
</template>

<script>
import Register from '@/components/admin/RegisterCoordinator'
import DataTable from '@/components/DataTable'
import Search from '@/components/Search'

export default {
  components:{
    'st-data-table': DataTable,
    'st-search': Search,
    'st-register': Register
  },
  mounted(){
    this.search('')
  },
  data () {
    return{
      componentKey: 0,
      dialog:false,
      items:[],
      loading: false,
      path:{
        url: '/admin/coordinadores/',
        id: 'idCoordinador'
      },
      headers: [
      {
        text: 'Nombre',
        align: 'start',
        value: 'nombres',
      },
      {
        text: 'Código',
        value: 'codigo'
      }
      ],
    }
  },
  methods:{
    open(){
      this.dialog = true
      this.componentKey += 1; //forceRerender
    },
    refresh(value){
      this.dialog = false
      this.search('')
    },
    async search(value){
      this.loading = true
      try{
        let { data: { data } } = await this.$api.getCoordinators(value)
        this.items = data
      } catch (e) {
        this.$store.commit('setError', e)
      }
      this.loading = false
    }
  }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
</style>
